#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <nrcvax.h>

#include "cdmod.h"

AtomRecord *ReadAtomRecord( FILE *cd_file, int atom_number )
{
    int ret_val;
    AtomRecord *atom = malloc( sizeof(*atom) );
    if( !atom ) return NULL;
    memset( atom, '\0', sizeof(*atom) );

    ret_val = fseek( cd_file, (atom_number + 7) * CD_RECL, SEEK_SET );
    if( -1 == ret_val ) {
        perror( "fseek()" );
        exit( EXIT_FAILURE );
    }
      
    ret_val = fread( atom, 1, CD_RECL, cd_file );
    if( ret_val == CD_RECL && 0 == strncmp(atom->params.at_name, "", 1) ) {
           free( atom );
           return NULL;
    }

    return atom;
}

void WriteAtomRecords( FILE *cd_file, struct atom_list *alist )
{
   struct atom_list *current;
   int ret;
   for( current = alist;
        current->next != NULL;
        current = current->next ) {
        ret = fseek( cd_file, (current->atom_num + 7) * CD_RECL, SEEK_SET );
        if( -1 == ret ) {
             perror( "fseek()" );
             exit(EXIT_FAILURE );
        }
        ret = fwrite( current->atom_record, 1, CD_RECL, cd_file ); 
        if( CD_RECL != ret ) {
            fputs( "Problem writing to .cd file.\n", stderr );
            exit( EXIT_FAILURE );
        }
   }
   return;
}
