#ifndef CDMOD_H
#define CDMOD_H

#include <stdio.h>
#include <nrcvax.h>

struct atom_list {
       struct atom_list *next;
       int atom_num;
       AtomRecord *atom_record;
       };

struct command {
       char *action_name;
       void *(*action)(AtomRecord *);
       char code;
       };

typedef char (*AtomNameArray)[ATOM_NAME_LEN];

#define LINE_LEN       80
#define CD_RECL       400
#define N_COL           4  /* atom list is output in 4 columns. */

/* prototypes */
extern AtomRecord *ReadAtomRecord(FILE *cd_file, int atom_number);
extern void WriteAtomRecords(FILE *cd_file, struct atom_list *alist);
extern void ModifyBondRecords(struct atom_list *alist);
extern void *OrderBondRecords(AtomRecord *record);
extern void *DeleteBondRecords(AtomRecord *record);
extern void Usage(const char *file);
extern char *ConvertNames(char *names);
extern AtomNameArray SplitAtomNameList(char *list);
extern int WordCount(const char *a);
extern void InitBondRecord( BondRecord *b);
extern char *SelectName(struct atom_list *list);
extern struct command *SelectAction(void);
extern int YesNo( const char *s );
#endif
