#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "cdmod.h"
static void N_Copy( AtomNameArray src, char *dst, size_t c_len, size_t t_len, int pad );

AtomNameArray SplitAtomNameList( char *list )
{
    AtomNameArray names;
    char *start_word,
         *end_word,
         *ptr;

    int  i,
         n_names = 0,
         in_name = 0;

   size_t len;

    n_names = WordCount( list );
    names = malloc( n_names * sizeof( *names ) );
    if( !names ) 
        return NULL;

    ptr = list;
    i = 0;
    while( *ptr && i < n_names ) {
      if( isalnum(*ptr) && 0 == in_name ) {
       in_name = 1;
       start_word = ptr;
       while( !isspace(*ptr) ) {
           if( ',' == *ptr  || '\0' == *ptr ) break;
           ptr++;
       }
       end_word = ptr;
       len = end_word - start_word + 1;
       N_Copy( &names[i], start_word, len - 1, ATOM_NAME_LEN, ' ' );
       i++;
      }
      else {
         in_name = 0;
         ptr++;
      }
    }

    return names;
}

static void N_Copy( AtomNameArray src, char *dst, size_t c_len, size_t t_len, int pad )
{
    char *s, *d;

    int i = 0;

    s = (char *)src;
    d = dst;

    while( i < c_len ) {
        *s++ = *d++;
        i++;
    }

    while( i < t_len ) {
        *s++ = pad;
        i++;
    }

    return;
}    

